#line 348 "/home/dodo/tmp/BB/bff-1.1/src/parse.u"

#line 106 "/home/dodo/tmp/BB/bff-1.1/src/parse.u"

typedef struct type
{
  int kind;
  int n_dimensions;
  int *dimensions;
  struct type *ref;
  char *name; // used for unresolved types
  void *obdef;  // used for resolved types
} type_t;

typedef struct field
{
  char *name;
  type_t *type;
  char *src;
  struct field *prev,*next;
} field_t;

typedef struct raw
{
  char *text;
  struct raw *prev,*next;
  char *src;
} raw_t;

typedef struct odef
{
  char *name;
  int top_level;
  char *src;
  field_t fields;
  raw_t raws;
  struct odef *prev,*next; 
  int aux;
  int typenumber;
} odef_t;

#define MAGICLEN 16

typedef struct
{
  odef_t odefs;
  char *sname,*hname,*pfx;
  unsigned int version;
  char magic[MAGICLEN];
  raw_t src_top, src_bot, hdr_top, hdr_bot;
  int has_magic;
} defile_t;

enum {
    TYPE_I8=1,    TYPE_U8,    TYPE_I16,   TYPE_U16,        TYPE_I32,
    TYPE_U32,     TYPE_I64,   TYPE_U64,   TYPE_F32,        TYPE_F64,
    TYPE_S8,      TYPE_S16,   TYPE_S32,   TYPE_UNRESOLVED, TYPE_SUB,
    TYPE_POINTER, TYPE_ARRAY, TYPE_DARRAY
    };


#line 62 "parse.h"

defile_t* parse_file(char* fn);
void resolve_unknown(defile_t *d);
int type_to_str(type_t *T,char *o);
#line 353 "/home/dodo/tmp/BB/bff-1.1/src/parse.u"

